# Bağlanış Vaxtı

Macarıstan $0$-dan $N - 1$-ə ədədlərlə nömrələnmiş $N$ sayda şəhərdən ibarət bir ölkədir.

Bu şəhərlər $0$-dan $N - 2$-yə ədədlərlə nömrələnmiş $N - 1$ sayda *qoşa istiqamətli* yol vasitəsilə birləşir.
$0 \le j \le N - 2$ aralığında hər bir $j$ üçün $j$ nömrəli yol $U[j]$ və $V[j]$ şəhərlərini birləşdirir və uzunluğu $W[j]$-dir. Bu o deməkdir ki, bu şəhərlər arasında $W[j]$ zamanda səyahət etmək olar. 
Hər bir yol iki müxtəlif şəhəri birləşdirir və istənilən iki şəhər arasında ən çox bir yol ola bilər. 

İki müxtəlif $a$ və $b$ şəhərləri arasında **keçid** $p_0, p_1, \ldots, p_t$ müxtəlif şəhərlər ardıcıllığı ilə işarə olunur. Burada:
 * $p_0 = a$,
 * $p_t = b$,
 * ($0 \le i \lt t$) aralığında hər bir $i$ üçün $p_i$ və $p_{i + 1}$ şəhərləri arasında yol var. 


Verilmiş yollardan istifadə etməklə istənilən şəhərdən istəniləninə getmək olar. Yəni, istənilən iki müxtəlif şəhər arasında keçid mövcuddur.
Göstərmək olar ki, istənilən iki müxtəlif şəhər arasında yalnız bir keçid var. 

$p_0, p_1, \ldots, p_t$ keçidinin **uzunluğu** bu keçid boyunca ardıcıl şəhərləri birləşdirən $t$ sayda yolun uzunluqları cəminə bərabərdir. 

Macarıstanda bir çox insan iki böyük şəhərdə Quruluş Günü festivallarında iştirak etmək üçün səyahət edir.
Festivallar bitdikdən sonra onlar evlərinə qayıdırlar.
Hökumət izdihamın yerli sakinləri narahat etməsinin qarşısını almaq istəyir, buna görə də müəyyən vaxtlarda şəhərləri bağlamağı planlaşdırır.
Hökumət tərəfindən hər bir şəhərə mənfi olmayan **bağlanış vaxtı** təyin ediləcək.
Hökumət qərara alıb ki, bütün bağlanış vaxtlarının cəmi $K$-dan çox olmamalıdır.
Daha dəqiq, $0$, $N - 1$ (hər ikisi daxil) arasındakı hər bir $i$ üçün $i$ şəhərinə təyin edilmiş bağlanış vaxtı mənfi olmayan $c[i]$ ədədidir. 
Bütün $c[i]$-lərin cəmi $K$-dan böyük olmamalıdır.


$a$ şəhəri və təyin olunmuş hər hansı bağlanış vaxtlarını düşünək.
Biz o vaxt $b$ şəhərinin $a$ şəhərindən **əlçatan** olduğunu deyirik ki, ya $b = a$-dır və ya bu iki şəhər arasındakı $p_0, \ldots, p_t$ keçidi ($p_0 = a$ və $p_t = b$) aşağıdakı şərtləri ödəyir:
 * $p_0, p_1$ keçidinin uzunluğu ən çox $c[p_1]$-dir,
 * $p_0, p_1, p_2$ keçidinin uzunluğu ən çox $c[p_2]$-dir,
 * $\ldots$
 * $p_0, p_1, p_2, \ldots, p_t$ keçidinin uzunluğu ən çox $c[p_t]$-dir.

Bu il iki əsas festival yeri $X$ və $Y$ şəhərində yerləşir.
Bağlanış vaxtlarının hər bir təyini üçün **rahatlıq balı** aşağıdakı iki ədədin cəmi kimi müəyyən edilir:
- $X$ şəhərindən çatmaq mümkün olan şəhərlərin sayı.
- $Y$ şəhərindən çatmaq mümkün olan şəhərlərin sayı.

Nəzərə alın ki, hər hansı şəhər həm $X$, həm də $Y$ şəhərindən əlçatandırsa, o rahatlıq balında *iki dəfə* sayılır.
Tapşırığınız, bağlanış vaxtlarının müəyyən təyinatı ilə əldə edilə bilən maksimum rahatlıq balını hesablamaqdır.

## İmplementasiya Detalları

Aşağıdakı proseduru implement etməlisiniz:

```
int max_score(int N, int X, int Y, int64 K, int[] U, int[] V, int[] W)
```

* $N$: şəhərlərin sayı.
* $X$, $Y$: festival yerləri olan şəhərlər.
* $K$: bağlanış vaxtlarının cəminin yuxarı limiti.
* $U$, $V$: yolları təsvir edən $N - 1$ uzunluqlu massivlər.
* $W$: yolların uzunluqlarını təsvir edən $N - 1$ uzunluqlu massiv.
* Bu prosedur bağlanış vaxtlarının müəyyən təyinatı ilə əldə edilə bilən maksimum rahatlıq balını qaytarmalıdır.
* Bu prosedur hər bir testdə **bir neçə dəfə** çağırıla bilər.


## Nümunə

Aşağıdakı çağırışı nəzərdən keçirək:

```
max_score(7, 0, 2, 10,
          [0, 0, 1, 2, 2, 5], [1, 3, 2, 4, 5, 6], [2, 3, 4, 2, 5, 3])
```

Bu, aşağıdakı yol şəbəkəsinə uyğundur:

![](closing-sample1.png)


Tutaq ki, bağlanış vaxtları aşağıdakı kimi təyin olunub:

| **Şəhər**         | $0$ | $1$ | $2$ | $3$ | $4$ | $5$ | $6$ |
|:----------------:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|
| **Bağlanış vaxtı** | $0$ | $4$ | $0$ | $3$ | $2$ | $0$ | $0$ |


Göründüyü kimi, bütün bağlanış vaxtlarının cəmi $9$-dur və bu $K = 10$-dan çox deyil. 
0$, $1$ və $3$ şəhərləri $X$ ($X = 0$) şəhərindən, $1$, $2$ və $4$ şəhərləri $Y$ ($Y = 2$) şəhərindən əlçatandır. 
Buna görə də, rahatlıq balı $3 + 3 = 6$-dır.
Bağlanış vaxtlarını elə təyin etmək mümkün deyil ki, rahatlıq balı $6$-dan çox olsun, beləcə prosedur $6$ qaytarmalıdır.

Aşağıdakı çağırışı da nəzərdən keçirək:

```
max_score(4, 0, 3, 20, [0, 1, 2], [1, 2, 3], [18, 1, 19])
```

Bu, aşağıdakı yol şəbəkəsinə uyğundur:

![](closing-sample2.png)

Tutaq ki, bağlanış vaxtları aşağıdakı kimi təyin olunub:

| **Şəhər**         | $0$ | $1$ | $2$ | $3$ |
|:----------------:|:---:|:---:|:---:|:---:|
| **Bağlanış vaxtı** | $0$ | $1$ | $19$| $0$ |

$0$ şəhəri $X$ ($X = 0$) şəhərindən, $2$ və $3$ şəhərləri isə $Y$ ($Y = 3$) şəhərindən əlçatandır. 
Buna görə də, rahatlıq balı $1 + 2 = 3$-dür.
Bağlanış vaxtlarını elə təyin etmək mümkün deyil ki, rahatlıq balı $3$-dən çox olsun, beləcə prosedur $3$ qaytarmalıdır.


## Məhdudiyyətlər

* $2 \le N \le 200\,000$
* $0 \le X \lt Y \lt N$
* $0 \le K \le 10^{18}$
* $0 \le U[j] \lt V[j] \lt N$ ($0 \le j \le N - 2$)
* $1 \le W[j] \le 10^6$ ($0 \le j \le N - 2$)
* Verilmiş yollardan istifadə etməklə istənilən şəhərdən istəniləninə getmək mümkündür.
* $S_N \le 200\,000$, burada $S_N$ hər bir testdə `max_score` proseduruna olan çağırışlardakı $N$-lərin cəmidir.


## Alt tapşırıqlar

Yol şəbəkəsi o zaman **xətti** adlanır ki, $i$ ($0 \le i \le N - 2$) yolu $i$ və $i + 1$ şəhərlərini birləşdirir. 

1. (8 bal) $X$ şəhərindən $Y$ şəhərinə olan keçidin uzunluğu $2K$-dan böyükdür.
1. (9 bal) $S_N \le 50$, yol şəbəkəsi xəttidir.
1. (12 bal) $S_N \le 500$, yol şəbəkəsi xəttidir.
1. (14 bal) $S_N \le 3\,000$, yol şəbəkəsi xəttidir.
1. (9 bal) $S_N \le 20$
1. (11 bal) $S_N \le 100$
1. (10 bal) $S_N \le 500$
1. (10 bal) $S_N \le 3\,000$
1. (17 bal) Əlavə məhdudiyyət yoxdur.


## Nümunə Qreyder

Gəlin $C$ ssenarilərin sayını, yəni `max_score` proseduruna olan çağırışların sayını bildirsin.
Nümunə qreyder giriş verilənlərini aşağıdakı şəkildə oxuyur:

* sətir $1$: $C$

Daha sonra $C$ sayda ssenarinin təsviri gəlir.

Nümunə qreyder hər bir ssenarinin təsvirini aşağıdakı şəkildə oxuyur:

* sətir $1$: $N \; X \; Y \; K$
* sətir $2 + j$ ($0 \le j \le N - 2$): $U[j] \; V[j] \; W[j]$

Nümunə qreyder hər bir ssenari üçün aşağıdakı şəkildə bir sətir çap edir:

* sətir $1$: `max_score` prosedurundan qayıdan dəyər.
