# Closing Time (Ώρες Απαγόρευσης Κυκλοφορίας)

Η Ουγγαρία είναι μια χώρα με $N$ πόλεις αριθμημένες από $0$ έως $N - 1$.

Οι πόλεις συνδέονται με $N - 1$ δρόμους *διπλής κατεύθυνσης*, αριθμημένους από $0$ έως $N - 2$.
Για κάθε $j$ τέτοιο ώστε $0 \le j \le N - 2$, ο δρόμος $j$ συνδέει την πόλη $U[j]$ και την πόλη $V[j]$ και έχει μήκος $W[j]$,
δηλαδή, επιτρέπει σε κάποιον να ταξιδέψει από τη μία πόλη στην άλλη σε $W[j]$ μονάδες χρόνου.
Κάθε δρόμος συνδέει δυο διαφορετικές πόλεις και κάθε ζεύγος πόλεων συνδέεται το πολύ με έναν δρόμο.

Ένα **μονοπάτι** μεταξύ δύο πόλεων $a$ και $b$ είναι μια αλληλουχία $p_0, p_1, \ldots, p_t$ διαφορετικών πόλεων, τέτοια ώστε:
 * $p_0 = a$,
 * $p_t = b$,
 * για κάθε $i$ ($0 \le i \lt t$), υπάρχει ένας δρόμος που συνδέει τις πόλεις $p_i$ και $p_{i + 1}$.

Είναι δυνατό να ταξιδέψουμε από οποιαδήποτε πόλη σε οποιαδήποτε άλλη πόλη χρησιμοποιώντας τους δρόμους, δηλαδή, υπάρχει μονοπάτι ανάμεσα σε δύο οποιεσδήποτε διαφορετικές πόλεις.
Το μονοπάτι αυτό είναι μοναδικό για κάθε ζεύγος πόλεων.

Το **μήκος** ενός μονοπατιού $p_0, p_1, \ldots, p_t$ είναι το άθροισμα των μηκών των $t$ δρόμων που συνδέουν τις διαδοχικές πόλεις κατά μήκος του μονοπατιού.

Στην Ουγγαρία, πολλοί άνθρωποι ταξιδεύουν για να παρακολουθήσουν τις εορταστικές εκδηλώσεις της ίδρυσης του κράτους σε δύο από τις πιο σημαντικές πόλεις.
Όταν οι εκδηλώσεις τελειώσουν, επιστρέφουν στις πόλεις διαμονής τους.
Η κυβέρνηση επιθυμεί να αποτρέψει το πλήθος των ταξιδιωτών να αναστατώνει τη ζωή των μόνιμων κατοίκων, οπότε σχεδιάζει να ορίσει μια απαγόρευση κυκλοφορίας στις πόλεις σε συγκεκριμένες ώρες.
Σε κάθε πόλη θα ανατεθεί μια μη-αρνητική **ώρα απαγόρευσης κυκλοφορίας** από την κυβέρνηση.
Η κυβέρνηση έχει αποφασίσει ότι το άθροισμα όλων των ωρών απαγόρευσης κυκλοφορίας δεν πρέπει να ξεπερνά έναν αριθμό $K$.
Πιο συγκεκριμένα, για κάθε $i$ μεταξύ $0$ και $N - 1$, συμπεριλαμβανομένων, η ώρα απαγόρευσης κυκλοφορίας που θα ανατεθεί στην πόλη $i$ είναι ένας μη αρνητικός ακέραιος $c[i]$.
Το άθροισμα όλων των $c[i]$ δεν πρέπει να είναι μεγαλύτερο από $K$.

Θεωρήστε μια πόλη $a$ και κάποιο χρόνο απαγόρευσης που της έχει ανατεθεί.
Λέμε ότι η πόλη $b$ είναι **προσβάσιμη** από την πόλη $a$ αν και μόνο αν ισχύει $b = a$, ή το μονοπάτι $p_0, \ldots, p_t$ μεταξύ των δύο πόλεων (πιο συγκεκριμένα $p_0 = a$ και $p_t = b$) ικανοποιεί τις ακόλουθες συνθήκες:
 * το μήκος του μονοπατιού $p_0, p_1$ είναι το πολύ $c[p_1]$, και
 * το μήκος του μονοπατιού $p_0, p_1, p_2$ είναι το πολύ $c[p_2]$, και
 * $\ldots$
 * το μήκος του μονοπατιού $p_0, p_1, p_2, \ldots, p_t$ είναι το πολύ $c[p_t]$.

Αυτή τη χρονιά, οι δύο κύριες πόλεις που θα διεξαχθούν εκδηλώσεις είναι οι πόλεις $X$ και $Y$.
Για κάθε ανάθεση ωρών απαγόρευσης κυκλοφορίας, ο **βαθμός ευκολίας** ορίζεται σαν το άθροισμα των δύο παρακάτω αριθμών:
- Ο αριθμός των πόλεων που είναι προσβάσιμες από την πόλη $X$.
- Ο αριθμός των πόλεων που είναι προσβάσιμες από την πόλη  $Y$.

Παρατηρήστε ότι αν μια πόλη είναι προσβάσιμη από την πόλη $X$ και είναι προσβάσιμη από την πόλη $Y$, μετρά *δύο φορές* στον βαθμό ευκολίας.

Υπολογίστε τον μέγιστο βαθμό ευκολίας που μπορεί να επιτευχθεί από κάποια ανάθεση ωρών απαγόρευσης κυκλοφορίας.


## Λεπτομέρειες Υλοποίησης

Να υλοποιήσετε την επόμενη συνάρτηση.

```
int max_score(int N, int X, int Y, int64 K, int[] U, int[] V, int[] W)
```

* $N$: ο αριθμός των πόλεων.
* $X$, $Y$: οι δύο κύριες πόλεις που θα γίνουν οι εκδηλώσεις.
* $K$: το μέγιστο όριο του αθροίσματος των ωρών απαγόρευσης κυκλοφορίας.
* $U$, $V$: πίνακες μεγέθους $N - 1$ που περιέχουν τις συνδέσεις των δρόμων.
* $W$: πίνακας μήκους $N - 1$ που περιέχει τα μήκη των δρόμων.
* Η διαδικασία αυτή πρέπει να επιστρέφει τον μέγιστο βαθμό ευκολίας που μπορεί να επιτευχθεί από κάποια ανάθεση ωρών απαγόρευσης κυκλοφορίας.
* Η συνάρτηση αυτή μπορεί να κληθεί **πολλές διαδοχικές φορές** σε κάθε test case.


## Παράδειγμα

Θεωρήστε την επόμενη κλήση:

```
max_score(7, 0, 2, 10,
          [0, 0, 1, 2, 2, 5], [1, 3, 2, 4, 5, 6], [2, 3, 4, 2, 5, 3])
```

Οι παράμετροι ανταποκρίνονται στο παρακάτω δίκτυο δρόμων:

![](closing-sample1.png)

Υποθέστε ότι έχουν ανατεθεί οι επόμενες ώρες απαγόρευσης κυκλοφορίας:

| **Πόλη**         | $0$ | $1$ | $2$ | $3$ | $4$ | $5$ | $6$ |
|:----------------:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|
| **Ώρα απαγόρευσης** | $0$ | $4$ | $0$ | $3$ | $2$ | $0$ | $0$ |

Παρατηρήστε ότι το άθροισμα όλων των ωρών απαγόρευσης είναι $9$, το οποίο δεν είναι μεγαλύτερο από $K = 10$.
Οι πόλεις $0$, $1$, και $3$ είναι προσβάσιμες από την πόλη $X$ ($X = 0$), ενώ οι πόλεις $1$, $2$, και $4$ είναι προσβάσιμες από την πόλη $Y$ ($Y = 2$).
Άρα ο βαθμός ευκολίας είναι  $3 + 3 = 6$.
Δεν υπάρχει άλλη δυνατή ανάθεση ωρών απαγόρευσης που να έχει βαθμό ευκολίας μεγαλύτερο από $6$, οπότε η συνάρτηση πρέπει να επιστρέψει $6$.

Επίσης, θεωρείστε την επόμενη κλήση:

```
max_score(4, 0, 3, 20, [0, 1, 2], [1, 2, 3], [18, 1, 19])
```

η οποία ανταποκρίνεται στο παρακάτω δίκτυο δρόμων:

![](closing-sample2.png)

Υποθέστε ότι έχουν ανατεθεί οι επόμενες ώρες απαγόρευσης κυκλοφορίας:

| **Πόλη**         | $0$ | $1$ | $2$ | $3$ |
|:----------------:|:---:|:---:|:---:|:---:|
| **Ώρα απαγόρευσης** | $0$ | $1$ | $19$| $0$ |

Η πόλη $0$ είναι προσβάσιμη από την πόλη $X$ ($X = 0$), ενώ οι πόλεις $2$ και $3$ είναι προσβάσιμες από την πόλη $Y$ ($Y = 3$).
Επομένως, ο βαθμός ευκολίας είναι $1 + 2 = 3$.
Δεν υπάρχει ανάθεση ωρών απαγόρευσης κυκλοφορίας με βαθμό ευκολίας μεγαλύτερο από $3$, οπότε η συνάρτηση πρέπει να επιστρέψει $3$.


## Περιορισμοί

* $2 \le N \le 200\,000$
* $0 \le X \lt Y \lt N$
* $0 \le K \le 10^{18}$
* $0 \le U[j] \lt V[j] \lt N$ (για κάθε $j$ τέτοιο ώστε $0 \le j \le N - 2$)
* $1 \le W[j] \le 10^6$ (για κάθε $j$ τέτοιο ώστε $0 \le j \le N - 2$)
* Είναι δυνατό να ταξιδέψουμε από οποιαδήποτε πόλη σε οποιαδήποτε άλλη πόλη χρησιμοποιώντας τους δρόμους.
* $S_N \le 200\,000$, όπου $S_N$ είναι το άθροισμα όλων των $N$ ανάμεσα στις διαδοχικές κλήσεις της `max_score`.


## Υποπροβλήματα

Λέμε ότι ένα δίκτυο δρόμων είναι **γραμμικό** αν ο δρόμος $i$ συνδέει τις πόλεις $i$ και $i + 1$ (για κάθε $i$ τέτοιο ώστε $0 \le i \le N - 2$).

1. (8 βαθμοί) Το μήκος του μονοπατιού μεταξύ των πόλεων $X$ και $Y$ είναι μεγαλύτερο από $2K$.
1. (9 βαθμοί) $S_N \le 50$ και το δίκτυο δρόμων είναι γραμμικό.
1. (12 βαθμοί) $S_N \le 500$ και το δίκτυο δρόμων είναι γραμμικό.
1. (14 βαθμοί) $S_N \le 3\,000$ και το δίκτυο δρόμων είναι γραμμικό.
1. (9 βαθμοί) $S_N \le 20$
1. (11 βαθμοί) $S_N \le 100$
1. (10 βαθμοί) $S_N \le 500$
1. (10 βαθμοί) $S_N \le 3\,000$
1. (17 βαθμοί) Χωρίς επιπλέον περιορισμούς.


## Ενδεικτικός Grader

Ας θεωρήσουμε ότι έχουμε $C$ σενάρια, δηλαδή, κλήσεις στη `max_score`.
Ο ενδεικτικός grader διαβάζει το αρχείο εισόδου στην επόμενη μορφή:

* γραμμή $1$: $C$

Οι περιγραφές των $C$ σεναρίων ακολουθούν.

Ο ενδεικτικός grader διαβάζει τις περιγραφές κάθε σεναρίου στην ακόλουθη μορφή:

* γραμμή $1$: $N \; X \; Y \; K$
* γραμμή $2 + j$ ($0 \le j \le N - 2$): $U[j] \; V[j] \; W[j]$

Ο ενδεικτικός grader τυπώνει μία μόνο γραμμή για κάθε σενάριο στην επόμενη μορφή:

* γραμμή $1$: η επιστρεφόμενη τιμή της συνάρτησης `max_score`