# Sulgemisajad

Ungaris on $N$ linna, mis on nummerdatud $0$ kuni $N - 1$.

Nende linnade vahel on $N - 1$ *kahesuunalist* maanteed, mis on nummerdatud $0$ kuni $N - 2$.
Maantee number $j$ (kus $0 \le j \le N - 2$) ühendab linnu $U[j]$ ja $V[j]$ ning selle pikkus on $W[j]$:
seda maanteed mööda on võimalik liikuda ühest linnast teise $W[j]$ ajaühikuga.
Iga maantee ühendab kaht erinevat linna ja iga kaht linna ühendab ülimalt üks maantee.

Kaht erinevat linna $a$ ja $b$ ühendav **teekond** on paarikaupa erinevate linnade jada $p_0, p_1, \ldots, p_t$, kus
 * $p_0 = a$,
 * $p_t = b$,
 * iga $0 \le i \lt t$ korral on linnade $p_i$ ja $p_{i + 1}$ vahel maantee.

On teada, et mistahes kahe erineva linna vahel leidub neid ühendav teekond.
Võib tõestada, et mistahes kahe erineva linna vahel on ainult üks teekond.

Teekonna $p_0, p_1, \ldots, p_t$ **pikkus** on $t$ teekonnal järjestikusi linnu ühendava maantee pikkuste summa.

Paljud ungarlased sõidavad iseseisvuspäevaks kahes suuremas linnas peetavatele pidustustele.
Pidustuste lõppedes pöörduvad nad koju tagasi.
Kohalike elanike häirimise vältimiseks plaanib valitsus iga linna mingil ajal liikluseks sulgeda.
Iga linna **sulgemisaeg** on mittenegatiivne täisarv ja nende summa ei tohi olla suurem kui $K$.
Täpsemalt on iga $0 \le i \le N - 1$ korral linna $i$ sulgemisaeg mittenegatiivne täisarv $c[i]$ ja kõigi $c[i]$ summa ei tohi olla suurem kui $K$.

Vaatleme nüüd linnu $a$ ja $b$ ning mingit sulgemisaegade komplekti.
Me ütleme, et linnast $a$ on **võimalik jõuda** linna $b$, kui kas $b = a$ või teekonnal $p_0, \ldots, p_t$ linnast $a$ linna $b$ (kus seega $p_0 = a$ ja $p_t = b$) kehtivad tingimused:
 * teekonna $p_0, p_1$ pikkus ei ületa $c[p_1]$ ja
 * teekonna $p_0, p_1, p_2$ pikkus ei ületa $c[p_2]$ ja
 * $\ldots$
 * teekonna $p_0, p_1, p_2, \ldots, p_t$ pikkus ei ületa $c[p_t]$.

Sel aastal on pidustused linnades $X$ ja $Y$.
Linnade sulgemisaegade komplekti **mugavushinne** on kahe arvu summa:
- nende linnade arv, kuhu on võimalik jõuda linnast $X$;
- nende linnade arv, kuhu on võimalik jõuda linnast $Y$.

Pane tähele, et kui mõnesse linna on võimalik jõuda nii linnast $X$ kui ka linnast $Y$, siis see linn läheb mugavushindes arvesse *kahekordselt*.

Sinu ülesanne on leida maksimaalne võimalik mugavushinne.

## Realisatsioon

Lahendusena tuleb realiseerida funktsioon

```
int max_score(int N, int X, int Y, int64 K, int[] U, int[] V, int[] W)
```

* $N$: linnade arv.
* $X$, $Y$: linnad, kus toimuvad pidustused.
* $K$: maksimaalne lubatud sulgemisaegade summa.
* $U$, $V$: $N - 1$ elemendiga massiivid, maanteede ühendatavad linnad.
* $W$: $N - 1$ elemendiga massiiv, maanteede pikkused.
* Funktsioon peab tagastama maksimaalse mugavushinde, mis on võimalik mingi sulgemisaegade komplektiga saavutada.
* Seda funktsiooni võidakse ühes testis käivitada **korduvalt**.

## Näide

Vaatleme väljakutset

```
max_score(7, 0, 2, 10,
          [0, 0, 1, 2, 2, 5], [1, 3, 2, 4, 5, 6], [2, 3, 4, 2, 5, 3])
```

Sellele vastab järgmine teedevõrk:

![](closing-sample1.png)

Oletame, et linnadele on määratud järgmised sulgemisajad:

| **Linn**         | $0$ | $1$ | $2$ | $3$ | $4$ | $5$ | $6$ |
|:----------------:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|
| **Sulgemisaeg**  | $0$ | $4$ | $0$ | $3$ | $2$ | $0$ | $0$ |

Pane tähele, et sulgemisaegade summa on $9$, mis ei ole suurem kui $K = 10$.
Linnast $X = 0$ on võimalik jõuda linnadesse $0$, $1$ ja $3$ ning linnast $Y = 2$ on võimalik jõuda linnadesse $1$, $2$ ja $4$.
Seega on selle sulgemisaegade komplekti mugavushinne $3 + 3 = 6$.
Kuna ühegi sulgemisaegade komplekti mugavushinne pole suurem kui $6$, peab funktsioon tagastama $6$.

Vaatleme nüüd väljakutset

```
max_score(4, 0, 3, 20, [0, 1, 2], [1, 2, 3], [18, 1, 19])
```

Sellele vastab järgmine teedevõrk:

![](closing-sample2.png)

Oletame, et linnadele on määratud järgmised sulgemisajad:

| **Linn**         | $0$ | $1$ | $2$ | $3$ |
|:----------------:|:---:|:---:|:---:|:---:|
| **Sulgemisaeg**  | $0$ | $1$ | $19$| $0$ |

Linnast $X = 0$ on võimalik jõuda linna $0$ ning linnast $Y = 3$ on võimalik jõuda linnadesse $2$ ja $3$.
Mugavushinne on seega $1 + 2 = 3$.
Kuna ühegi sulgemisaegade komplekti mugavushinne pole suurem kui $3$, peab funktsioon tagastama $3$.

## Piirangud

* $2 \le N \le 200\,000$.
* $0 \le X \lt Y \lt N$.
* $0 \le K \le 10^{18}$.
* $0 \le U[j] \lt V[j] \lt N$ iga $0 \le j \le N - 2$ korral.
* $1 \le W[j] \le 10^6$ iga $0 \le j \le N - 2$ korral.
* Leidub teekond igast linnast igasse teise linna.
* $S_N \le 200\,000$, kus $S_N$ on $N$ väärtuste summa üle kõigi `max_score` väljakutsete ühes testis.

## Alamülesanded

Ütleme, et teedevõrk on **lineaarne** kui iga $0 \le i \le N - 2$ korral maantee number $i$ ühendab linnu $i$ ja $i + 1$.

1. (8 punkti) Teekond linnast $X$ linna $Y$ on pikem kui $2K$.
1. (9 punkti) $S_N \le 50$ ja teedevõrk on lineaarne.
1. (12 punkti) $S_N \le 500$ ja teedevõrk on lineaarne.
1. (14 punkti) $S_N \le 3\,000$ ja teedevõrk on lineaarne.
1. (9 punkti) $S_N \le 20$.
1. (11 punkti) $S_N \le 100$.
1. (10 punkti) $S_N \le 500$.
1. (10 punkti) $S_N \le 3\,000$.
1. (17 punkti) Lisapiirangud puuduvad.

## Hindamisprogramm

Olgu $C$ funktsiooni `max_score` väljakutsete arv ühes testis.

Arhiivis olev hindamisprogramm loeb sisendi järgmises vormingus:

* rida $1$: $C$

Järgnevad $C$ stsenaariumi kirjeldused.

Hindamisprogramm loeb iga stsenaariumi kirjelduse järgmises vormingus:

* rida $1$: $N \; X \; Y \; K$
* rida $2 + j$ (kus $0 \le j \le N - 2$): $U[j] \; V[j] \; W[j]$

Hindamisprogramm väljastab iga stsenaariumi kohta ühe rea järgmises vormingus:

* rida $1$: funktsiooni `max_score` tagastatud väärtus
