# ჩაკეტვის დრო

უნგრეთში $N$ რაოდენობის ქალაქია, რომლებიც გადანომრილია რიცხვებით $0$ -დან $(N-1)$ -მდე.
ქალაქები ერთმანეთთან შეერთებულია $(N - 1)$ რაოდენობის ორმხრივი გზებით. გზები ასევე გადანომრილია რიცხვებით $0$-დან to $(N - 2)$-ის ჩათვლით.

ყოველი გზა $j$ ( $0 \le j \le N - 2$) სიგრძით $W[j]$, აკავშირებს ქალაქებს $U[j]$ და $V[j]$. გზის სიგრძე წარმოადგენს შესაბამის ქალაქებს შორის გადაადგილების
ხანგრძლივობას.
ყოველი გზა აკავშირებს ორ განსხვავებულ ქალაქს, ასევე ყოველი ორი ქალაქი დაკავშირებულია მაქსიმუმ ერთი გზით.

ორ განსხვავებულ  $a$ და $b$ ქალაქს შორის **მარშრუტი** ვუწოდოთ განსხვავებული $p_0, p_1, \ldots, p_t$ ქალაქების ისეთ მიმდევრობას, რომ:
 * $p_0 = a$,
 * $p_t = b$,
 * ყოველი $i$ რიცხვისთვის ($0 \le i \lt t$), არსებობს გზა , რომელიც აკავშირებს ქალაქებს $p_i$ და $p_{i + 1}$.

არსებული გზებით შესაძლებელია მოგზაურობა ნებისმიერი ქალაქიდან ნებისმიერ სხვა ქალაქამდე. ანუ, ნებისმიერი ორი განსხვავებული ქალაქი დაკავშირებულია ერთადერთი მარშრუტით. 

$p_0, p_1, \ldots, p_t$ მარშრუტის **სიგრძე** არის მასში შემავალი გზების სიგრძეთა ჯამი.

უნგრეთში ბევრი ადამიანი მოგზაურობს, რათა დაესწროს ზოგი მსხვილი ქალაქის დაარსების დღესასწაულს. დღესასწაულის დასრულებისას ისინი ბრუნდებიან სახლში.

ქვეყნის მთავრობას სურს შეამციროს დიდი რაოდენობით ხალხის თავმოყრა, რათა ადგილობრივი მოსახლეობა ნაკლებად შეწუხდეს. ამიტომ დაგეგმილია გარკვეულ დროებში ქალაქების ჩაკეტვა. 

ყველა ქალაქს მთავრობამ უნდა მიანიჭოს გარკვეული არაუარყოფითი **ჩაკეტვის დრო**. მთავრობამ ასევე გადაწყვიტა, რომ ჩაკეტვის დროების სრული ჯამი არ უნდა აღემატებოდეს მოცემულ $K$ სიდიდეს. უფრო ზუსტად, ყველა $i$ რიცხვისთვის $0$ -დან  $(N - 1)$-ის ჩათვლით,  $i$ ქალაქის ჩაკეტვის დრო არის არაუარყოფითი $c[i]$ მთელი რიცხვი და ყველა ამ $c[i]$ რიცხვების ჯამი არ უნდა აღემატებოდეს $K$ სიდიდეს. 

განვიხილოთ $a$ ქალაქი და ჩაკეტვის დროების გარკვეული განაწილება.
ვთქვათ, $b$ ქალაქი **მიღწევადია** $a$  ქალაქიდან მაშინ და მხოლოდ მაშინ, თუ  $b = a$, ან ამ ორ ქალაქს შორის მარშრუტი $p_0, \ldots, p_t$  (კერძოთ $p_0 = a$ და $p_t = b$) აკმაყოფილებს შემდეგ პირობებს:
 * $p_0, p_1$ მარშრუტის სიგრძე არ აღემატება სიდიდეს $c[p_1]$, და
 * $p_0, p_1, p_2$ მარშრუტის სიგრძე არ აღემატება სიდიდეს $c[p_2]$, და
 * $\ldots$
 * $p_0, p_1, p_2, \ldots, p_t$ მარშრუტის სიგრძე არ აღემატება სიდიდეს $c[p_t]$.

წელს გაიმართება ორი მთავარი $X$ და $Y$ ქალაქის დაარსების დღესასწაული.
ყველა განსაზღვრული ჩაკეტვის დროებისთვის  **კომფორტულობის ქულა** განსაზღვროთ შემდეგი ორი რიცხვის ჯამის სახით:
- $X$ ქალაქიდან მიღწევადი ქალაქების რაოდენობა.
- $Y$ ქალაქიდან მიღწევადი ქალაქების რაოდენობა.

გაითვალისწინეთ, რომ თუ რომელიმე ქალაქი მიღწევადია როგორც $X$, ასევე $Y$ ქალაქიდან, მაშინ კომფორტულობის ქულაში ის უნდა ჩაითვალოს ორჯერ.

თქვენი დავალებაა გარკვეული ჩაკეტვის დროებისთვის გამოთვალოთ კომფორტულობის ქულის მაქსიმალური მნიშვნელობა.


## იმპლემენტაციის დეტალები

თქვენ უნდა მოახდინოთ შემდეგი პროცედურის იმპლემენტაცია.

```
int max_score(int N, int X, int Y, int64 K, int[] U, int[] V, int[] W)
```

* $N$:  ქალაქების რაოდენობა.
* $X$,  $Y$: მთავარი ქალაქები, სადაც ტარდება დღესასწაულები.
* $K$:  ჩაკეტვის დროების ჯამის ზედა ზღვარი.
* $U$, $V$:  $N - 1$ სიგრძის მასივები, რომლებიც აღწერენ დამაკავშირებელ გზებს.
* $W$:  $N - 1$ სიგრძის მასივი, რომელიც აღწერს გზების სიგრძეებს.
* ამ პროცედურამ უნდა დააბრუნოს კომფორტულობის მაქსიმალური ქულა, რომელიც შეიძლება იყოს მიღებული რომელიმე ჩაკეტვის დროების განაწილებით.
* ყველა ტესტში ეს პროცედურა შესაძლოა მრავალჯერ იყოს გამოძახებული.


## მაგალითი

განვიხილოთ შემდეგი გამოძახება:

```
max_score(7, 0, 2, 10,
          [0, 0, 1, 2, 2, 5], [1, 3, 2, 4, 5, 6], [2, 3, 4, 2, 5, 3])
```

ის შეესაბამება გზების შემდეგ ქსელს:

![](closing-sample1.png)

დავუშვათ ჩაკეტვის დროები დანიშნულია შემდეგი განაწილების სახით:

| **ქალაქი**         | $0$ | $1$ | $2$ | $3$ | $4$ | $5$ | $6$ |
|:----------------:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|
| **ჩაკეტვის დრო** | $0$ | $4$ | $0$ | $3$ | $2$ | $0$ | $0$ |

გაითვალისწინეთ, რომ ყველა ჩაკეტვის დროების ჯამი არ აღემატება სიდიდეს 
$K = 10$. 

ქალაქები $0$, $1$ და $3$ მიღწევადია ქალაქიდან $X$ ($X = 0$), ამავე დროს  ქალაქები $1$, $2$ და $4$ მიღწევადია ქალაქიდან $Y$ ($Y = 2$).
შედეგად კომფორტულობის ქულა არის $3 + 3 = 6$.
არ არსებობს განაწილება, რომლის შესაბამისი კომფორტულობის ქულა მეტია, ვიდრე $6$, ამიტომ პროცედურამ უნდა დააბრუნოს $6$.

ასევე განვიხილოთ შემდეგი გამოძახება:

```
max_score(4, 0, 3, 20, [0, 1, 2], [1, 2, 3], [18, 1, 19])
```

ის შეესაბამება გზების შემდეგ ქსელს:

![](closing-sample2.png)

დავუშვათ ჩაკეტვის დროები დანიშნულია შემდეგი განაწილების სახით:

| **ქალაქი**         | $0$ | $1$ | $2$ | $3$ |
|:----------------:|:---:|:---:|:---:|:---:|
| **ჩაკეტვის დრო** | $0$ | $1$ | $19$| $0$ |

ქალაქი $0$ მიღწევადია ქალაქიდან $X$ ($X = 0$), ამავე დროს ქალაქები $2$ და $3$ მიღწევადია ქალაქიდან $Y$ ($Y = 3$).
შედეგად კომფორტულობის ქულა არის $1 + 2 = 3$.
არ არსებობს განაწილება, რომლის შესაბამისი კომფორტულობის ქულა მეტია, ვიდრე $3$, ამიტომ პროცედურამ უნდა დააბრუნოს $3$.


## შეზღუდვები

* $2 \le N \le 200\,000$
* $0 \le X \lt Y \lt N$
* $0 \le K \le 10^{18}$
* $0 \le U[j] \lt V[j] \lt N$ (ყველა ისეთი $j$ რიცხვისთვის, სადაც $0 \le j \le N - 2$)
* $1 \le W[j] \le 10^6$ (ყველა ისეთი $j$ რიცხვისთვის, სადაც $0 \le j \le N - 2$)
* მოცემული გზებით შესაძლებელია ნებისმიერი ქალაქიდან ნებისმიერ სხვა ქალაქში გადააადგილება.
* $S_N \le 200\,000$, სადაც $S_N$ არის ყველა `max_score` პროცედურის გამოძახებებისთვის  $N$  სიდიდეების ჯამი.


## ქვეამოცანები

ვიტყვით, რომ გზების ქსელი **წრფივია**, თუ გზა $i$ აკავშირებს ქალაქებს $i$ და $i + 1$ (ყველა $i$-სათვის, სადაც  $0 \le i \le N - 2$).

1. (8 ქულა) მარშრუტის სიგრძე $X$ ქალაქიდან $Y$ ქალაქამდე მეტია, ვიდრე $2K$.
1. (9 ქულა) $S_N \le 50$, გზების ქსელი წრფივია.
1. (12 ქულა) $S_N \le 500$, გზების ქსელი წრფივია.
1. (14 ქულა) $S_N \le 3\,000$, გზების ქსელი წრფივია.
1. (9 ქულა) $S_N \le 20$
1. (11 ქულა) $S_N \le 100$
1. (10 ქულა) $S_N \le 500$
1. (10 ქულა) $S_N \le 3\,000$
1. (17 ქულა) დამატებითი შეზღუდვების გარეშე.


## სანიმუშო გრადერი

ვთქვათ $C$ აღნიშნავს სცენარების რაოდენობას, თუ რამდენჯერ იქნება გამოძახებული პროცედურა `max_score`.
სანიმუშო გრადერი კითხულობს შემავალ მონაცემებს შემდეგი ფორმატით:

* სტრიქონი $1$: $C$

ამის შემდეგ მოცემულია $C$ სცენარის აღწერა.

სანიმუშო გრადერი კითხულობს ყველა სცენარის აღწერას შემდეგი ფორმატით

* სტრიქონი $1$: $N \; X \; Y \; K$
* სტრიქონი $2 + j$ ($0 \le j \le N - 2$): $U[j] \; V[j] \; W[j]$

სანიმუშო გრადერი ბეჭდავს ერთ სტრიქონს ყოველი სცენარისთვის შემდეგი ფორმატით:

* სტრიქონი $1$: `max_score` პროცედურის დაბრუნებული მნიშვნელობა.
