# Closing Time

Ungverjaland hefur $N$ borgir, númeraðar frá $0$ til $N-1$

Borgirnar eru tengdar með $N-1$ *tvíáttuðum* vegum, númeraðir frá $0$ til $N-2$.
Fyrir sérhvert $j$, þannig að $0 \le j \le N - 2$, þá tengir vegur $j$ borgina $U[j]$ við borgina $V[j]$, með lengd $W[j]$,
sem þýðir að hægt sé að ferðast á milli borganna á $W[j]$ tíma einingum.
Hver vegur tengir tvær mismunandi borgir og sérhvert par af borgum er í mesta lagi tengt með einum veg.

**Leið** á milli tveggja mismunandi borga $a$ og $b$ er runan $p_0, p_1, \ldots, p_t$, sem samanstendur af mismunandi borgum, þannig að:
 * $p_0 = a$,
 * $p_t = b$,
 * fyrir sérhvert $i$ ($0 \le i \lt t$), þá er vegur á milli borganna $p_i$ og $p_{i + 1}$.

Það er hægt að ferðast frá sérhverri borg til sérhverrar annarrar borgar með því að nota vegi, þannig að það er til leið á milli allra mismunandi para af borgum.
Hægt er að sýna fram á að þessi leið er mismunandi fyrir sérhvert par af borgum.

**Lengdin** á leið $p_0, p_1, \ldots, p_t$ er summan af lengd allra $t$ mismunandi vega sem tengja samliggjandi borgir í leiðinni.

Í Ungverjalandi ferðast margir til að mæta á hátíðir á stofnunardegi Ungverjalands í sumum stærstu borgunum.
Þegar hátíðarhöldum er lokið, fara allir heim til sín.
Ríkið vill passa upp á að fólkið trufli ekki heimamenn, þannig planið þeirra er að loka borgunum á ákveðnum tímum.
Hverri borg verður úthlutuð **lokunartíma** frá ríkinu sem er ekki neikvæður.
Ríkið hefur ákveðið að summa þessa lokunartíma skal ekki vera hærri en $K$.
Nánar tiltekið, fyrir sérhvert $i$ á milli $0$ og $N-1$, með báðum meðtöldum, þá er lokunartími borgar $i$ heiltala $c[i]$ sem er ekki neikvæð.
Summan af öllum $c[i]$ skal ekki vera stærri en $K$.

Íhugið borg $a$ og einhvern úthlutaðan lokunartíma.
Við segjum að borg $b$ sé **aðgengileg** frá borg $a$ þá og því aðeins að $b = a$, eða leiðin $p_0, \ldots, p_t$ á milli borganna (þá sérstaklega $p_0 = a$ og $p_t = b$)
fullnægir eftirfarandi skilyrðum:
* Lengd leiðarinnar $p_0, p_1$ er í mesta lagi  $c[p_1]$, og
* Lengd leiðarinnar $p_0, p_1, p_2$ er í mesta lagi  $c[p_2]$, og
* $\ldots$
* Lengd leiðarinnar  $p_0, p_1, p_2, \ldots, p_t$ er í mesta lagi  $c[p_t]$.

Þetta árið eru tveir helstu hátíðarstaðirnir í borgum $X$ og $Y$.
Fyrir hverja úthlutun af lokunartímum, þá eru **þægindastigin** skilgreind sem summa af eftirfarandi tvem tölum:
- Fjöldi borga sem eru aðgengilegar frá borg $X$.
- Fjöldi borga sem eru aðgengilegar frá borg $Y$.

Takið eftir því að ef borg er aðgengileg frá borg $X$ og einnig aðgengileg frá borg $Y$, þá telja þægindastigin *tvisvar*

Þitt verkefni er að reikna hæsta gildi þægindastiga sem hægt er að ná með einhverri úthlutun lokunartíma.


## Útfærsluatriði

Þú skalt útfæra eftirfarandi fall.

```
int max_score(int N, int X, int Y, int64 K, int[] U, int[] V, int[] W)
```

* $N$: fjöldi borga
* $X$, $Y$: tvær helstu borginnar.
* $K$: efri mörk á summu lokunnartíma.
* $U$, $V$: fylki af lengd $N - 1$ sem lýsa tengingum milli borganna.
* $W$: fylki af lengd $N - 1$ sem lýsir vegalengdum.
* Þetta fall skal skila hæsta gildi þægindarstiga sem hægt er að ná með einhverri úthlutun lokunartíma.
* Sérhvert prufutilvik gæti kallað í þetta fall **mörgum sinnum**.

## Sýnidæmi

Íhugið eftirfarandi kall:

```
max_score(7, 0, 2, 10,
          [0, 0, 1, 2, 2, 5], [1, 3, 2, 4, 5, 6], [2, 3, 4, 2, 5, 3])
```

Þetta samsvarar eftirfarandi vegakerfi.

![](closing-sample1.png)

Gerið ráð fyrir eftirfarandi lokunartímum:

| **Borg**         | $0$ | $1$ | $2$ | $3$ | $4$ | $5$ | $6$ |
|:----------------:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|
| **Lokunartími** | $0$ | $4$ | $0$ | $3$ | $2$ | $0$ | $0$ |

Takið eftir að summa allra lokunartíma er $9$, sem er ekki meira en $K = 10$.
Borgir $0$, $1$ og $3$ er aðgengilegra frá borg $X$ ($X = 0$), á meðan borgir $1$, $2$ og $4$ eru aðgengilegar frá borg $Y$ ($Y = 2$).
Þannig að þægindastigin eru því $3 + 3 = 6$.
Það er engin úthlutun lokunartíma með þægindastig meira en $6$, þannig fallið skal skila $6$.

Takið einnig eftir eftirfarandi kalli:

```
max_score(4, 0, 3, 20, [0, 1, 2], [1, 2, 3], [18, 1, 19])
```

Þetta samsvarar eftirfarandi vegakerfi.

![](closing-sample2.png)

Gerið ráð fyrir eftirfarandi lokunartímum:

| **Borg**         | $0$ | $1$ | $2$ | $3$ |
|:----------------:|:---:|:---:|:---:|:---:|
| **Lokunartími** | $0$ | $1$ | $19$| $0$ |

Borg $0$ er aðgengileg frá borg $X$ ($X = 0$), á meðan borgir $2$ og $3$ eru aðgengilegar frá borg $Y$ ($Y = 3$).
Þannig að þægindastigin eru því $1 + 2 = 3$.
Það er engin úthlutun lokunartíma með þægindastig meira en $3$, þannig fallið skal skila $3$.

## Skorður

* $2 \le N \le 200\,000$
* $0 \le X \lt Y \lt N$
* $0 \le K \le 10^{18}$
* $0 \le U[j] \lt V[j] \lt N$ (fyrir sérhvert $j$ þannig að $0 \le j \le N - 2$)
* $1 \le W[j] \le 10^6$ (fyrir sérhvert $j$ þannig að $0 \le j \le N - 2$)
* Mögulegt er að ferðast frá öllum borgum til allra borga með því að nota vegi.
* $S_N \le 200\,000$, þar sem $S_N$ er summan af $N$ yfir öll köll í `max_score` í sérhverju prufutilveki.


## Hlutverkefni

Við segjum að vegakerfi sé **línulegt** ef vegir $i$ tengja borgir $i$ og $i + 1$ (fyrir sérhvert $i$ þannig að $0 \le i \le N - 2$).

1. (8 points) Lengdin á leiðinni frá borg $X$ að borg $Y$ er hærri en $2K$.
1. (9 points) $S_N \le 50$, vegakerfið er línulegt.
1. (12 points) $S_N \le 500$, vegakerfið er línulegt.
1. (14 points) $S_N \le 3\,000$, vegakerfið er línulegt.
1. (9 points) $S_N \le 20$
1. (11 points) $S_N \le 100$
1. (10 points) $S_N \le 500$
1. (10 points) $S_N \le 3\,000$
1. (17 points) Engar frekari skorður.


## Sýnisyfirferðarforrit

Látum $C$ tákna fjölda atburða, það er, fjölda kalla í `max_score`.
Sýnisyfirferðarforrit les inntakið á eftirfarandi sniði:

* lína $1$: $C$

Lýsinguna á $C$ má sjá að ofan.

Sýnisyfirferðarforritið les lýsinginuna á hverjum atburði á eftirfarandi sniði:

* lína $1$: $N \; X \; Y \; K$
* lína $2 + j$ ($0 \le j \le N - 2$): $U[j] \; V[j] \; W[j]$

Sýnisyfirferðarforritið skrifar út eina línu fyrir hvern atburð á eftirfarandi sniði:

* lína $1$: skilagildið á  `max_score`
