# Хаалтын цаг

Унгар бол N хоттой улс бөгөөд тэдгээр хотууд нь 0-ээс N-1 дугаартай.
Хотууд нь $N - 1$ тооны **хоёр чиглэлтэй** $0$-ээс $N-2$ дугаартай замуудаар холбогдсон байдаг.

$j$-р зам бүрийн хувьд ($0 \le j \le N - 2$) $U[j]$ болон $V[j]$ хотууд холбогдсон бөгөөд W[j] урттай байдаг. Энэ нь хоёр хотуудын хооронд нэг удаа аялахдаа W[j] хугацаа зарцуулдаг. Зам бүр нь хоёр ялгаатай хотуудыг холбосон ба хотуудын хос бүр нь хамгийн ихдээ нэг замаар холбогдсон байдаг.
Ялгаатай хоёр $a$, $b$ хотуудыг холбосон **маршрут** (path) гэж $p_0, p_1, \ldots, p_t$ гэсэн ялгаатай хотуудын дараалал юм.

Тухайлбал
* $p_0=a$,

* $p_t=b$

* $i$ бүрийн хувьд ($0 \le i \lt t$) $p_i$ болон $p_{i+1}$ хотуудыг хооронд холбосон зам байна.

Замуудыг ашиглан аль ч хотоос өөр хот руу явах боломжтой, өөрөөр хэлбэл хоёр ялгаатай хот бүрийн хооронд маршрут оршин байдаг. Энэ маршрут нь ялгаатай хотуудын хос бүр нь дахин давтагдашгүй болохыг харуулж байна.

$p_0, p_1, \ldots, p_t$ маршрутын **урт** нь маршрутын дагуух дараалсан хотуудыг хоорондох  *t* замуудын уртуудын нийлбэр байна.

Унгарт олон хүмүүс Улс тунхагласны баяраар хоёр гол хотын хооронд аялдаг. Баяр дуусангуут тэд нар гэр гэрлүүгээ буцдаг. Засгийн газар цугласан олныг нутгийн иргэдийг үймүүлэхээс урьдчилан сэргийлэхийг хүсч байгаа тул тодорхой цагт бүх хотуудыг түр хаахаар төлөвлөж байна.
Хот бүрт засгийн газраас сөрөг бус **хаалтын цаг**-ийг олгоно.
Засгийн газар бүх хаалтын цагийн нийлбэр нь К-ээс ихгүй байхаар шийдвэрлэсэн. Тодруулбал, $0$ -ээс $N - 1$ хоорондох $i$ хот бүрийн хувь дахь олгогдсон хаалтын цаг сөрөг бус бүхэл тоо $c[i]$ байна.  
Бүх $c[i]$-уудын нийлбэр нь $K$-аас ихгүй байна.

Зарим хаалтын цагуудын олголт болон $a$ хотыг авч үзье. $b$ хотыг $a$ хотоос **хүрч болох** гэж хэлж чадах зайлшгүй бөгөөд хүрэлцээтэй нөхцөл бол $b = a$ байх эсвэл тэдгээр хоёр хотуудын хоорондох маршрут нь $p_0, \ldots, p_t$ ( $p_0 = a$ ба $p_t = b$ байх) дараах нөхцөлүүдийг хангах ёстой:
* $p_0, p_1$ хоорондох маршрутын урт нь хамгийн ихдээ $c[p_1]$
* $p_0, p_1, p_2$ хоорондох маршрутын урт нь хамгийн ихдээ $c[p_2]$
* $\ldots$
*  $p_0, p_1, p_2, \ldots, p_t$ хоорондох маршрутын урт нь хамгийн ихдээ $c[p_t]$ байна.

Энэ жил хоёр гол баяр нь $X$ болон $Y$ хотод болно. Хаалтын цагуудын олголт бүрд тав тухтай байдлын оноо гэдэг нь дараах хоёр тооны нийлбэрээр тодорхойлогдоно:
* $X$ хотоос хүрч болох хотуудын тоо.
* $Y$ хотоос хүрч болох хотуудын тоо.

Хэрэв нэг хотод нь $X$ хотоос мөн $Y$ хотоос хүрэх боломжтой бол тав тухтай байдлын оноонд *хоёр удаа* тоологдоно гэдгийг анхаарах хэрэгтэй.

Таны даалгавар бол хаалтын цагуудын зарим олголтуудаар хүрэх хамгийн их тав тухтай байдлын оноог тооцоолох юм.

## Хэрэгжүүлэлтийн мэдээлэл

Та дараах процедурыг хэрэгжүүлэх юм.

```
int max_score(int N, int X, int Y, int64 K, int[] U, int[] V, int[] W)
```
Үүнд:
* $N$: хотуудын тоо.
* $X$, $Y$: гол баяр болж байгаа хотууд
* $K$: хаалтын цагуудын нийлбэрийн дээд хязгаар
* $U$, $V$: $N - 1$ урттай замын холболтуудыг тодорхойлсон массив 
* $W$: $N - 1$ урттай замын уртуудыг илэрхийлэх массив
* Энэ процедур зарим хаалтын цагуудын олголтоор хүрэх хамгийн их тав тухтай байдлын оноог буцаах ёстой.
* Тестийн тохиолдол бүрт энэ процедурыг **олон дахин** дуудаж болно.

## Жишээ
Дараах дуудалтыг авч үзвэл:

```
max_score(7, 0, 2, 10,
          [0, 0, 1, 2, 2, 5], [1, 3, 2, 4, 5, 6], [2, 3, 4, 2, 5, 3])
```
Дараах замын сүлжээ энд тохирно.
![](closing-sample1.png)

Хаалтын цагууд дараах байдлаар олгогдохыг харж болно:

| **Хот**         | $0$ | $1$ | $2$ | $3$ | $4$ | $5$ | $6$ |
|:----------------:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|
| **Хаалтын цаг** | $0$ | $4$ | $0$ | $3$ | $2$ | $0$ | $0$ |


Бүх хаалтын цагуудын нийлбэр нь 9 байгааг харж болно. Энд $K = 10$ -аас хэтрэхгүй байна.
$0$, $1$, and $3$ хотуудад $X$ ($X = 0$) хотоос хүрч болно. Мөн $1$, $2$, and $4$ хотуудад $Y$ ($Y = 2$) хотоос хүрч болох төдийгүй тав тухтай байдлын оноо $3 + 3 = 6$ байна.
Энд $6$-гаас их байх тав тухтай байдлын оноотой хаалтын цагуудын олголт байхгүй байгаа учраас, процедур 6-г буцаах ёстой болно.

Мөн дараах дуудалтыг авч үзвэл:
```
max_score(4, 0, 3, 20, [0, 1, 2], [1, 2, 3], [18, 1, 19])
```
Түүнд таарах дараах замын сүлжээ байна:

![](closing-sample2.png)

Хаалтын цагуудын олголт нь дараах байдалтай байна:

| **Хот**         | $0$ | $1$ | $2$ | $3$ |
|:----------------:|:---:|:---:|:---:|:---:|
| **Хаалтын цаг** | $0$ | $1$ | $19$| $0$ |

$X$ ($X = 0$) хотоос хүрэх 0 хот байна. $Y$ ($Y = 3$) хотоос хүрэх хотууд нь $2$ ба $3$ байх төдийгүй тав тухтай байдлын оноо нь $1 + 2 = 3$ байна. $3$-аас их байх тав тухтай байдлын оноотой хаалтын цагуудын олголт байхгүй байгаа учраас процедур $3$-ийг буцаах ёстой.

## Хязгаарлалт

* $2 \le N \le 200\,000$
* $0 \le X \lt Y \lt N$
* $0 \le K \le 10^{18}$
* $0 \le U[j] \lt V[j] \lt N$ ($j$ бүрийн хувьд $0 \le j \le N - 2$)
* $1 \le W[j] \le 10^6$ ($j$ бүрийн хувьд $0 \le j \le N - 2$)
* Хоёр хотын хоорондох замуудыг ашиглаад ямар нэг хотоос өөр нэг хотруу аялах боломжтой.
* $S_N \le 200\,000$, $S_N$ нь тестийн тохиолдол бүрийн бүх `max_score` дуудалтуудын N-үүдийн нийлбэр болно.

## Дэд бодлогууд

Бид замын сүлжээ шугаман гэж хэдийд хэлэх вэ гэхээр $i$ зам нь $i$ ба $i + 1$ хотуудыг хооронд нь холбосон байвал ($i$ бүрийн хувьд $0 \le i \le N - 2$).


1. (8 points) $X$ хотоос $Y$ хот хүрэх маршрутын урт нь $2K$-аас их үед.
1. (9 points) $S_N \le 50$, замын сүлжээ шугаман бол
1. (12 points) $S_N \le 500$, замын сүлжээ шугаман бол
1. (14 points) $S_N \le 3\,000$, замын сүлжээ шугаман бол
1. (9 points) $S_N \le 20$
1. (11 points) $S_N \le 100$
1. (10 points) $S_N \le 500$
1. (10 points) $S_N \le 3\,000$
1. (17 points) Хязгаарлалтгүй.


## Жишээ градер

Нийт сценарын тоог $C$ гэе, энэ бол `max_score` дуудалтын тоо юм.
Жишээ градер дараах форматаар оролтыг уншина:

* $1$-р мөрөнд : $C$

$C$ сценаруудын тайлбар дараах байдалтай

Жишээ градер дараах форматаар сценар бүрийн тайлбарыг уншина:

* $1$-р мөрөнд: $N \; X \; Y \; K$
* $2 + j$-р мөрөнд ($0 \le j \le N - 2$): $U[j] \; V[j] \; W[j]$

Жишээ градер сценар бүрт нэг мөр хэвлэнэ дараах форматаар:
* $1$ мөрөнд:  `max_score`-ийн утгыг буцаана.



