# وقت الإغلاق

يوجد في هنغايا $N$ مدينة، مرقمة من $0$ إلى $N-1$.

لدى المدن $N - 1$ وصلة $ $ *ثنائية الاتجاه*، مرقمة من $0$ إلى  $N - 2$.

من أجل كل $j$ (حيث $0 \le j \le N-2$)، الطريق $j$ يصل المدينة $U[j]$ والمدينة $V[j]$
من أجل $j$ بحيث $0 \le j \le N - 2$, الطريق$j$ يصل المدينة $U[j]$ والمدينة $V[j]$ وطوله $W[j]$,
ذلك يعني أنه يسمح للشخص بأن يسافر بين المدينتين خلال 
 $W[j]$ 
 وحدة زمن. 
 كل طريق يربط مدينتين مختلفتين، وكل زوج من المدن متصل بطريق واحد على الأكثر

**المسار** بين مدينتين مختلفتين $a$ و $b$ هو سلسلة 
 $p_0, p_1, \ldots, p_t$ 
من المدن المختلفة، بحيث أن
 * $p_0 = a$,
 * $p_t = b$,
 * من أجل $i$ ($0 \le i \lt t$), يوجد طريق يصل المدينتين $p_i$ و $p_{i + 1}$.

من الممكن السفر من أي مدينة إلى أي مدينة أخرى باستخدام الطرقات، ذلك يعني أنه يوجد مسار بين أي مدينتين مختلفتين.
كما أنه من الممكن أن نستنتج أن المسار بين أي زوج من المدن هو مسار وحيد.

**طول المسار** 
 $p_0, p_1, \ldots, p_t$ 
هو مجموع أطوال الطرق التي عددها $t$ التي تصل كل مدينتين متتاليتين ضمن المسار

يسافر الناس عادة في هنغاريا للمشاركة في مهرجانات اليوم الوطني والتي تقام في مدينتين رئيسيتين.
وفور انتهاء الاحتفالات، يعود الناس إلى بيوتهم. تريد الحكومة منع الحشود من ازعاج السكان المحليين، لذلك قاموا بوضع خطة  تعتمد على إغلاق كل المدن في أوقات محددة.
سيتم إعطاء **وقت إغلاق** لكل مدينة وهو عدد غير سالب يحدد من قبل الحكومة. وقررت الحكومة أن مجموع أوقات الإغلاق يجب أن لا يكون أكثر من $K$.
بشكل أدق، من أجل كل 
$i$ بين $0$ و $N - 1$, متضمنة الرقمين , وقت الإغلاق المحدد للمدينة $i$ هو العدد الصحيح غير السالب $c[i]$.
مجموع قيم كل $c[i]$ يجب أن لا يكون أكبر من $K$.

لتكن المدينة $a$ وقد تم تحديد قيم أوقات الإغلاق بطريقة ما. نقول عن المدينة $b$ بأنها **قابلة للوصل** من المدينة $a$ إذا وفقط إذا كان $a$ = $b$ أو أن المسار
 $p_0, \ldots, p_t$ بين هاتين المدينتين (أي أنه $p_0 = a$ و $p_t = b$) يحقق الشروط التالية
 * طول المسار $p_0, p_1$ هو على الأكثر  $c[p_1]$, و
 * طول المسار $p_0, p_1, p_2$ هو على الأكثر $c[p_2]$, و
 * $\ldots$
 * طول المسار $p_0, p_1, p_2, \ldots, p_t$ هو على الأكثر $c[p_t]$.

في هذا العام، هناك مهرجانان رئيسيان تتم إقامتهما في المدينتين $X$ و $Y$.
من أجل أي توزيع لأوقات الإغلاق يكون **الدرجة المناسبة** معرفاً بأنه مجموع عددين هما:

- عدد المدن التي يمكن الوصول إليها من المدينة $X$.
- عدد المدن التي يمكن الوصول إليها من المدينة $Y$.

لاحظ انه إذا كانت المدينة قابلة للوصول من الدينة $X$ وقابلة للوصول أيضاً من المدينة $Y$ نقوم باحتسابها *مرتين* عند حساب الدرجة المناسبة.

مهمتك هي حساب أكبر درجة مناسبة يمكن الحصول عليها عن طريق توزيع ما لأوقات اللإغلاق.


## تفاصيل البرمجة

يجب عليك برمجة الإجرائية التالية

```
int max_score(int N, int X, int Y, int64 K, int[] U, int[] V, int[] W)
```

* $N$: عدد المدن.
* $X$, $Y$:المدينتان اللتان سيقام فيهما المهرجانان الرئيسيان.
* $K$: الحد الأعلى لمجموع أوقات الإغلاق.
* $U$, $V$: مصفوفتان طولهما $N - 1$ تصفان وصلات الطرق.
* $W$:مصفوفة طولها $N - 1$ تحدد أطوال الطرق.
* تعيد هذه الإجرائية أكبر درجة مناسبة يمكن الحصول عليها عن طريق توزيع ما لأوقات الإغلاق.
* يمكن أن يتم استدعاء هذه الإجرائية **عدة مرات** في حالة الاختبار الواحدة.

## مثال
ليكن الاستدعاء التالي

```
max_score(7, 0, 2, 10,
          [0, 0, 1, 2, 2, 5], [1, 3, 2, 4, 5, 6], [2, 3, 4, 2, 5, 3])
```

الذي يعبر عن شبكة الطراقت التالية:

![](closing-sample1.png)

لنفرض ان اوقات الإغلاق قد تم تحديدها كما الجدول التالي:


| **المدينة**         | $0$ | $1$ | $2$ | $3$ | $4$ | $5$ | $6$ |
|:----------------:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|
| **وقت الإغلاق*** | $0$ | $4$ | $0$ | $3$ | $2$ | $0$ | $0$ |

لاحظ أن مجموع كل أوقات الإغلاق هو $9$، والذي لم يتجاوز 
$K = 10$. 
المدن$0$, $1$, و $3$ يمكن الوصول إليها من المدينة $X$ ($X = 0$), أما المدن $1$, $2$, and $4$ يمكن الوصول إليها من المدينة $Y$ ($Y = 2$).
لذلك فإن الدرجة المناسبة العظمى التي يمكن الوصول إليها هي $3 + 3 = 6$.
لا يوجد أي توزيع آخر لأوقات الإغلاق يمكن من خلاله الوصول إلى قيمة درجة مناسبة أكبر من $9$ لذلك يجب على الإجرائية أن تعيد القيمة $6$


أيضاً لنفرض الاستدعاء التالي

```
max_score(4, 0, 3, 20, [0, 1, 2], [1, 2, 3], [18, 1, 19])
```

والذي يعبر عن شبكة الطرقات التالية:

![](closing-sample2.png)

لنفرض أن أوقات الإغلاق قد تم تحديدها كما في الجدول التالي

| **المدينة**         | $0$ | $1$ | $2$ | $3$ |
|:----------------:|:---:|:---:|:---:|:---:|
| **وقت الإغلاق** | $0$ | $1$ | $19$| $0$ |

المدينة $0$ يمكن الوصول إليها من المدينة $X$ ($X = 0$), أما المدينتان $2$ و $3$يمكن الوصول إليهما من المدينة $Y$ ($Y = 3$).
لذلك فإن الدرجة المناسبة هي $1 + 2 = 3$.
لا يوجد أي توزيع آخر يمكن أن نحصل من خلاله على درجة مناسبة أكبر من  $3$, لذلك على الإجرائية أن تعيد القيمة $3$.

## الحدود

* $2 \le N \le 200\,000$
* $0 \le X \lt Y \lt N$
* $0 \le K \le 10^{18}$
* $0 \le U[j] \lt V[j] \lt N$ (من اجل كل $j$ بحيث $0 \le j \le N - 2$)
* $1 \le W[j] \le 10^6$ (من أجل كل $j$ بحيث $0 \le j \le N - 2$)
* من الممكن السفر من أي مدينة إلى اي مدينة أخرى من خلال الطرقات.
* $S_N \le 200\,000$, حيث $S_N$ هو مجموع قيم  $N$ في كل استدعاءات `max_score` في كل حالة اختبار.

## المسائل الجزئية

نقول عن شبكة الطرق أنها **خطية** إذا كان الطريق $i$ يصل المدينتين $i$ and $i + 1$ (من أجل كل $i$ بحيث $0 \le i \le N - 2$).

1. (8 درجة) طول المسار من المدينة $X$ إلى المدينة $Y$ أكبر من $2K$.
1. (9 درجة) $S_N \le 50$, شبكة الطرقات خطية.
1. (12 درجة) $S_N \le 500$, شبكة الطرقات خطية.
1. (14 درجة) $S_N \le 3\,000$, شبكة الطرقات خطية.
1. (9 درجة) $S_N \le 20$
1. (11 درجة) $S_N \le 100$
1. (10 درجة) $S_N \le 500$
1. (10 درجة) $S_N \le 3\,000$
1. (17 درجة) لا يوجد قيود إضافية.

## Sample Grader

Let $C$ denote the number of scenarios, that is, the number of calls to `max_score`.
The sample grader reads the input in the following format:

\* line $1$: $C$

The descriptions of $C$ scenarios follow.

The sample grader reads the description of each scenario in the following format:

\* line $1$: $N \; X \; Y \; K$
\* line $2 + j$ ($0 \le j \le N - 2$): $U[j] \; V[j] \; W[j]$

The sample grader prints a single line for each scenario, in the following format:

\* line $1$: the return value of `max_score`



