# เวลาปิด

ฮังการีเป็นประเทศที่มี $N$ เมือง แต่ละเมืองระบุด้วยตัวเลข $0$ to $N-1$

เมืองสองเมืองเชื่อมต่อกันด้วยถนนสองทิศทาง $N-1$ เส้น กำหนดด้วยหมายเลข $0$ ถึง $N-2$
โดยถนนหมายเลข $j$ สำหรับแต่ละ $j$ ที่ $0 \le j \le N - 2$ เชื่อมต่อเมือง $U[j]$ กับ $V[j]$ และมีความยาว $W[j]$ นั่นคือ เราสามารถเดินทางระหว่างเมืองคู่ดังกล่าวโดยใช้เวลา $W[j]$ หน่วย ถนนแต่ละเส้นจะเชื่อมต่อเมืองสองเมืองที่แตกต่างกัน และคู่ของเมืองใด ๆ จะเชื่อมต่อด้วยถนนไม่เกินหนึ่งเส้น

**เส้นทาง**ระหว่างสองเมือง $a$ กับ $b$ ที่แตกต่างกัน เป็นลำดับของเมือง $p_0, p_1, \ldots, p_t$ ที่แตกต่างกันซึ่ง
 * $p_0 = a$
 * $p_t = b$
 * ในแต่ละ  $i$ ($0 \le i \lt t$), จะมีถนนเชื่อมเมือง $p_i$ กับ $p_{i + 1}$

เราสามารถเดินทางจากเมืองใด ๆ ไปเมืองอื่นใดก็ได้ด้วยถนนเหล่านี้ หรืออีกนัยหนึ่งคือ จะมีเส้นทางระหว่างทุกสองเมืองที่แตกต่างกัน
โดยสามารถแสดงได้ว่า คู่ของเมืองแต่ละคู่มีเส้นทางเพียงหนึ่งเดียว

**ความยาว** ของเส้นทาง  $p_0, p_1, \ldots, p_t$ เป็นความยาวรวมของถนน $t$ เส้น ที่เชื่อมต่อเมืองที่อยู่ติดกันตามเส้นทางนี้

ในฮังการี คนจำนวนมากเดินทางเพื่อร่วมงานเฉลิมฉลองวันสถาปนารัฐซึ่งจัดในเมืองใหญ่สองเมือง
และเมื่องานจบ คนเหล่านี้ก็เดินทางกลับบ้าน
รัฐบาลต้องการป้องกันไม่ให้ผู้คนไปรบกวนคนท้องถิ่นจึงได้วางแผนที่จะปิดเมืองทั้งหมด ณ เวลาต่างๆ
รัฐบาลจะกำหนด **เวลาปิด** ของแต่ละเมืองเป็นจำนวนไม่เป็นลบ รัฐบาลตัดสินใจให้ผลรวมของเวลาปิดต้องมีค่าไม่เกิน $K$ 
กล่าวให้ชัดเจนขึ้นคือ สำหรับทุก $i$ ตั้งแต่ $0$ ถึง $N-1$ รวมหัวท้าย เวลาปิดที่กำหนดไว้ให้เมือง $i$ เป็นจำนวนเต็มไม่ติดลบ $c[i]$ โดยผลรวมของ $c[i]$ ทั้งหมดต้องมีค่าไม่เกิน $K$

พิจารณาเมือง $a$ กับการกำหนดเวลาปิดรูปแบบหนึ่ง
เรากล่าวว่าเมือง $b$ สามารถ **ไปถึงได้** จากเมือง $a$ ก็ต่อเมื่อ $b = a$ หรือมีเส้นทาง $p_0, \ldots, p_t$  ระหว่างสองเมืองนี้ (โดยเจาะจงว่า $p_0 = a$ และ $p_t = b$) ซึ่งเป็นไปตามข้อกำหนดดังต่อไปนี้:
* ความยาวของเส้นทาง $p_0, p_1$ มีค่าไม่เกิน $c[p_1]$ และ
* ความยาวของเส้นทาง $p_0, p_1, p_2$ มีค่าไม่เกิน $c[p_2]$ และ
* $\ldots$
* ความยาวของเส้นทาง $p_0, p_1, p_2, \ldots, p_t$ มีค่าไม่เกิน $c[p_t]$ 

ในปีนี้ การเฉลิมฉลองมีจุดหลักอยู่สองจุด คือที่เมือง $X$ กับเมือง $Y$
ในการกำหนดเวลาปิดแต่ละรูปแบบ นิยาม **ค่าความสะดวก** เป็นผลรวมของสองจำนวน:
- จำนวนเมืองที่สามารถไปถึงได้จากเมือง $X$
- จำนวนเมืองที่สามารถไปถึงได้จากเมือง $Y$

สังเกตว่าจะถ้ามีเมืองที่สามารถไปถึงได้จากเมือง $X$ และไปถึงได้จากเมือง $Y$ เมืองนั้นจะถูกนับเป็น*สองครั้ง*ในค่าความสะดวก

งานของคุณคือ คํานวณหาค่าความสะดวกที่มากที่สุดที่สามารถทำได้จากการกำหนดเวลาปิดรูปแบบใดรูปแบบหนึ่ง

## รายละเอียดการเขียนโปรแกรม

คุณต้องเขียนฟังก์ชันต่อไปนี้:

```
int max_score(int N, int X, int Y, int64 K, int[] U, int[] V, int[] W)
```

* $N$: จำนวนเมือง
* $X$, $Y$: เมืองที่เป็นจุดหลักของการเฉลิมฉลอง
* $K$: ค่าผลรวมเวลาปิดที่มากที่สุดที่อนุญาต
* $U$, $V$: อาร์เรย์ความยาว $N - 1$ ระบุการเชื่อมต่อถนน
* $W$: อาร์เรย์ความยาว $N - 1$ ระบุความยาวถนน
* ฟังก์ชันต้องคืนค่าความสะดวกที่มากที่สุดจากการกำหนดเวลาปิดสักรูปแบบหนึ่ง
* ฟังก์ชันนี้อาจจะถูกเรียกได้ **หลายครั้ง** ในแต่ละข้อมูลทดสอบ


## ตัวอย่าง

พิจารณาการเรียกฟังก์ชันต่อไปนี้:

```
max_score(7, 0, 2, 10,
          [0, 0, 1, 2, 2, 5], [1, 3, 2, 4, 5, 6], [2, 3, 4, 2, 5, 3])
```

ซึ่งสอดคล้องกันกับเครือข่ายถนนดังต่อไปนี้:

![](closing-sample1.png)

สมมติให้การกำหนดเวลาปิดเป็นดังต่อไปนี้:

| **เมือง**         | $0$ | $1$ | $2$ | $3$ | $4$ | $5$ | $6$ |
|:----------------:|:---:|:---:|:---:|:---:|:---:|:---:|:---:|
| **เวลาปิด** | $0$ | $4$ | $0$ | $3$ | $2$ | $0$ | $0$ |

สังเกตว่าผลรวมของเวลาปิดคือ $9$ ซึ่งไม่มากกว่า $K = 10$ เมือง $0$, $1$ และ $3$ สามารถไปถึงได้จากเมือง  $X$ ($X = 0$) ในขณะที่เมือง $1$, $2$, and $4$ สามารถไปถึงได้จากเมือง $Y$ ($Y = 2$) ดังนั้นค่าความสะดวกคือ  $3 + 3 = 6$
เนื่องจากไม่มีการกำหนดเวลาปิดรูปแบบใดที่ทำให้ค่าความสะดวกมากกว่า $6$ ดังนั้นฟังก์ชันต้องคืนค่า $6$

นอกจากนี้พิจารณาการเรียกฟังก์ชันต่อไปนี้:

```
max_score(4, 0, 3, 20, [0, 1, 2], [1, 2, 3], [18, 1, 19])
```

ซึ่งสอดคล้องกันกับเครือข่ายถนนดังต่อไปนี้:

![](closing-sample2.png)

สมมติให้การกำหนดเวลาปิดเป็นดังต่อไปนี้:

| **เมือง**         | $0$ | $1$ | $2$ | $3$ |
|:----------------:|:---:|:---:|:---:|:---:|
| **เวลาปิด** | $0$ | $1$ | $19$| $0$ |

เมือง $0$ สามารถไปถึงได้จากเมือง $X$ ($X = 0$) ในขณะที่เมือง $2$ และ $3$ สามารถไปถึงได้จากเมือง $Y$ ($Y = 3$).
ดังนั้นค่าความสะดวกคือ $1 + 2 = 3$.
เนื่องจากไม่มีการกำหนดเวลาปิดรูปแบบใดที่ทำให้ค่าความสะดวกมากกว่า $3$ ดังนั้นฟังก์ชันต้องคืนค่า $3$


## ข้อจำกัด

* $2 \le N \le 200\,000$
* $0 \le X \lt Y \lt N$
* $0 \le K \le 10^{18}$
* $0 \le U[j] \lt V[j] \lt N$ (สำหรับทุก $j$ ซึ่ง $0 \le j \le N - 2$)
* $1 \le W[j] \le 10^6$ (สำหรับทุก $j$ ซึ่ง $0 \le j \le N - 2$)
* สามารถเดินทางจากเมืองใด ๆ ไปเมืองอื่นใดก็ได้โดยใช้ถนนเหล่านี้
* $S_N \le 200\,000$ โดย $S_N$ เป็นผลรวมของค่า $N$ ทั้งหมด จากการเรียก `max_score` ทุกครั้งรวมกันในข้อมูลทดสอบหนึ่ง


## ปัญหาย่อย

เราเรียกเครือข่ายถนนว่า **เป็นเส้นตรง** ถ้าถนน $i$ เชื่อมต่อเมือง $i$ กับ $i+1$  (สำหรับทุก $i$ ซึ่ง $0 \le i \le N - 2$)

1. (8 คะแนน) ความยาวของเส้นทางจากเมือง  $X$ ถึงเมือง $Y$ มากกว่า $2K$
1. (9 คะแนน) $S_N \le 50$, เครือข่ายถนนเป็นเส้นตรง
1. (12 คะแนน) $S_N \le 500$, เครือข่ายถนนเป็นเส้นตรง
1. (14 คะแนน) $S_N \le 3\,000$, เครือข่ายถนนเป็นเส้นตรง
1. (9 คะแนน) $S_N \le 20$
1. (11 คะแนน) $S_N \le 100$
1. (10 คะแนน) $S_N \le 500$
1. (10 คะแนน) $S_N \le 3\,000$
1. (17 คะแนน) ไม่มีข้อจำกัดเพิ่มเติม


##  เกรดเดอร์ตัวอย่าง

ให้ $C$ เป็นจำนวนสถานการณ์ หรือก็คือ จำนวนครั้งที่จะเรียกฟังก์ชัน `max_score`
เกรดเดอร์ตัวอย่างอ่านข้อมูลนำเข้าตามรูปแบบต่อไปนี้:

* บรรทัดที่ $1$: $C$

จากนั้นต่อด้วยคำบรรยายของทั้ง $C$ สถานการณ์

เกรดเดอร์ตัวอย่างอ่านคำบรรยายสำหรับแต่ละสถานการณ์ตามรูปแบบต่อไปนี้:

* บรรทัดที่ $1$: $N \; X \; Y \; K$
* บรรทัดที่ $2 + j$ ($0 \le j \le N - 2$): $U[j] \; V[j] \; W[j]$

เกรดเดอร์ตัวอย่างพิมพ์ค่าหนึ่งบรรทัดสำหรับแต่ละสถานการณ์ตามรูปแบบต่อไปนี้:

* บรรทัดที่ $1$: ค่าที่คืนจากฟังก์ชัน `max_score`
